<!doctype html>
<html lang="en">

<head>
    <meta charset="utf-8">

    <title>Keycloak</title>

    <meta name="description" content="...">
    <meta name="author" content="Stian Thorgersen">

    <meta name="apple-mobile-web-app-capable" content="yes"/>
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent"/>

    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <link rel="stylesheet" href="css/reveal.min.css">
    <link rel="stylesheet" href="css/theme/keycloak.css" id="theme">

    <link href='http://fonts.googleapis.com/css?family=Ubuntu+Mono|Ubuntu|Ubuntu+Condensed' rel='stylesheet'
          type='text/css'>

    <!-- For syntax highlighting -->
    <link rel="stylesheet" href="lib/css/zenburn.css">

    <!-- If the query includes 'print-pdf', use the PDF print sheet -->
    <script>
        document.write('<link rel="stylesheet" href="css/print/' + ( window.location.search.match(/print-pdf/gi) ? 'pdf' : 'paper' ) + '.css" type="text/css" media="print">');
    </script>

    <!--[if lt IE 9]>
    <script src="lib/js/html5shiv.js"></script>
    <![endif]-->
</head>

<body>

<div class="reveal">
<div class="slides">
<section>
    <h1>Keycloak</h1>

    <h3>One password to rule them all</h3>

    <p>
        <small>hamid khanjani / khanjani.hamid@gmail.com</small>
    </p>
</section>

<section>
    <h2>Why?</h2>

    <ul>
        <li>Browsers, mobiles and clouds</li>
        <li>Many accounts</li>
        <li>Admin headache</li>
    </ul>
</section>

<section>
    <h2>Features</h2>
    <ul>
        <li>SSO</li>
        <li>Admin console</li>
        <li>Login forms</li>
        <li>Account management</li>
        <li>Multi-factor auth</li>
        <li>Social login</li>
        <li>...</li>
    </ul>
</section>

<section>
    <p>Why implement all that yourself?</p>
</section>

<section>
    <section>
        <h2>Overview</h2>

        <img src="overview.png"/>
    </section>
    <section>
        <h2>Realms</h2>

        <ul>
            <li>Config</li>
            <li>Realm Roles</li>
        </ul>
    </section>
    <section>
        <h2>Application</h2>

        <ul>
            <li>Redirect URIs</li>
            <li>Web Origins (CORS)</li>
            <li>Application Roles</li>
            <li>Scope</li>
        </ul>
    </section>
    <section>
        <h2>Clients</h2>

        <ul>
            <li>Redirect URIs</li>
            <li>Web Origins (CORS)</li>
            <li>Scope</li>
        </ul>
    </section>
    <section>
        <h2>Users</h2>

        <ul>
            <li>Profile</li>
            <li>Credentials</li>
            <li>Roles</li>
        </ul>
    </section>
</section>

<section>
    <section>
        <h2>App Login</h2>

        <p>Rest and redirects!</p>

        <p>
            <small>OAuth2</small>
        </p>
    </section>
    <section>
        <img src="how-1.png"/>
    </section>
    <section>
        <img src="how-2.png"/>
    </section>
    <section>
        <img src="how-3.png"/>
    </section>
    <section>
        <p>Token contains details about the user and permissions</p>

        <p>
            <small>JSON Web Token (JWT) & JSON Web Signature (JWS)</small>
        </p>
    </section>
    <section>
        <img src="how-4.png"/>
    </section>
    <section>
        <p>Token is signed so can be verified without contacting Keycloak</p>
    </section>
</section>

<section>
    <section>
        <h2>Client Grants</h2>

        <p>Can request access to a resource on behalf of a user</p>
    </section>
    <section>
        <img src="grants-1.png"/>
    </section>
    <section>
        <img src="grants-2.png"/>
    </section>
    <section>
        <img src="grants-3.png"/>
    </section>
    <section>
        <p>App exchanges code for token and passes token with requests...</p>
    </section>
</section>

<section>
    <section>
        <h2>Admin Console</h2>

        <p>Centralized management console for realms, applications and users</p>
    </section>
    <section>
        <img src="admin-console.png"/>
    </section>
</section>

<section>
    <section>
        <h2>Login Forms</h2>
        <ul>
            <li>Login</li>
            <li>Registration</li>
            <li>Login workflows
                <ul>
                    <li>Recover password</li>
                    <li>Reset password</li>
                    <li>Update profile</li>
                    <li>...</li>
                </ul>
            </li>
        </ul>
    </section>
    <section>
        <img src="login-1.png"/>
    </section>
    <section>
        <img src="login-2.png"/>
    </section>
</section>

<section>
    <section>
        <h2>Account Management</h2>
        <ul>
            <li>Profile</li>
            <li>Password</li>
            <li>Multi-factor auth</li>
        </ul>
    </section>
    <section>
        <img src="account-management.png"/>
    </section>
</section>

<section>
    <section>
        <h2>Social</h2>

        <p>Users can login with their Google, Facebook or Twitter accounts</p>
    </section>
    <section>
        <img src="social.png"/>
    </section>
</section>

<section>
    <section>
        <h2>What's Next?</h2>
        <ul>
            <li>Audit</li>
            <li>Theme support for login forms and account management</li>
            <li>View available apps in account management</li>
            <li>Manage client grants in account management</li>
            <li>Adapters for HTML5, Android, iOS, Native</li>
            <li>Federation (ActiveDirectory, LDAP, Relational database, ...)</li>
            <li>More social providers (GitHub, LinkedIn, ...)</li>
            <li>More multifactor authentication (YubiKey, Email, SMS)</li>
            <li>NoSQL store</li>
            <li>OpenID Connect</li>
            <li>Broker authentication (single password on many servers/realms)</li>
            <li>SAML?</li>
            <li>...</li>
        </ul>
    </section>
</section>

<section>
    <section>
        <h1><a href="">keycloak.org</a></h1>

        <p>just released!</p>

        <p>
            <small>#sso here</small>
        </p>
    </section>
</section>


<section>
    <h1>Demo time?</h1>

    <p>TODO</p>
</section>

<section>
    <h1>That's all folks!</h1>

    <h3>Any questions?</h3>

    <p>
        <small>hamid khanjani / khanjani.hamid@gmail.com</small>
    </p>
</section>

</div>

</div>

<script src="lib/js/head.min.js"></script>
<script src="js/reveal.min.js"></script>

<script>

    // Full list of configuration options available here:
    // https://github.com/hakimel/reveal.js#configuration
    Reveal.initialize({
        controls: true,
        progress: true,
        history: true,
        center: true,

        theme: Reveal.getQueryHash().theme, // available themes are in /css/theme
        transition: Reveal.getQueryHash().transition || 'default', // default/cube/page/concave/zoom/linear/fade/none

        // Parallax scrolling
        // parallaxBackgroundImage: 'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg',
        // parallaxBackgroundSize: '2100px 900px',

        // Optional libraries used to extend on reveal.js
        dependencies: [
            { src: 'lib/js/classList.js', condition: function () {
                return !document.body.classList;
            } },
            { src: 'plugin/markdown/marked.js', condition: function () {
                return !!document.querySelector('[data-markdown]');
            } },
            { src: 'plugin/markdown/markdown.js', condition: function () {
                return !!document.querySelector('[data-markdown]');
            } },
            { src: 'plugin/highlight/highlight.js', async: true, callback: function () {
                hljs.initHighlightingOnLoad();
            } },
            { src: 'plugin/zoom-js/zoom.js', async: true, condition: function () {
                return !!document.body.classList;
            } },
            { src: 'plugin/notes/notes.js', async: true, condition: function () {
                return !!document.body.classList;
            } }
        ]
    });

</script>

</body>
</html>
